#include <SPI.h>  
#include <MFRC522.h> 
#include <Wire.h> 
#include <LiquidCrystal_I2C.h>
#include <Servo.h>
LiquidCrystal_I2C lcd(0x27,16,2);
#define SS_PIN 10
#define RST_PIN 9
#define BUZZER 2
#define LED_G 4 //led verde
MFRC522 mfrc522(SS_PIN, RST_PIN);   
Servo myServo;
int i;
int *aux;
int card1[4];
int flag = 0;
int led = 13;
int cnt =0;
int startAlarm = false;
void setup() {
        pinMode(led, OUTPUT);
        pinMode(LED_G, OUTPUT);
        lcd.init();
        lcd.backlight();
    SPI.begin();        
    mfrc522.PCD_Init();   
        lcd.print(" Apropie cardul");
        lcd.setCursor(0,1);
        lcd.print(" De acces  ");

        myServo.attach(5); 
        myServo.write(0);
        pinMode(BUZZER, OUTPUT);
         noTone(BUZZER);
}

void loop() {
   
    if ( ! mfrc522.PICC_IsNewCardPresent()) {
        return;
    }

   
    if ( ! mfrc522.PICC_ReadCardSerial()) {
        return;
    }

   
    
    for (byte i = 0; i < mfrc522.uid.size; i++) {
            aux[i]= mfrc522.uid.uidByte[i];
    } 
           if(flag == 0)
           {
             lcd.clear();
             lcd.print("   Card UID:    ");
             lcd.setCursor(0,1);
             for (byte i = 0; i < mfrc522.uid.size; i++) {
               card1[i] = aux[i];
             lcd.print( card1[i], DEC);
             lcd.print( " ");
             flag =1;
            }
           delay(3000);
           lcd.clear();
           lcd.print(" Prezinta cartela");
           lcd.setCursor(0,1);
           lcd.print("  De acces   ");
           } 

           else{
            
           
             for (byte i = 0; i < mfrc522.uid.size; i++) {
               if(aux[i] == card1[i])
                cnt++;
             }
                            
            if(cnt == mfrc522.uid.size-1)
            {
              lcd.clear();
              lcd.print("     ACCES     ");
              lcd.setCursor(0,1);
              lcd.print("     PERMIS    ");
              delay(200);
              digitalWrite(LED_G, HIGH);//led on
              tone(BUZZER, 500);
              delay(300);
              noTone(BUZZER);
               myServo.write(180);//motor on
               delay(5000);
               myServo.write(0);//motor off
               digitalWrite(LED_G, LOW);//led off
             }
             else
             {
              lcd.clear();
              lcd.print("     ACCES     ");
              lcd.setCursor(0,1);
              lcd.print("    INTERZIS     ");
              delay(2000);
               tone(BUZZER, 300);
               delay(1000);
                 noTone(BUZZER);
             }
             
           }
          
           lcd.clear();
           lcd.print(" Apropie cardul");
           lcd.setCursor(0,1);
           lcd.print("  De acces   ");
           
  cnt=0;

}
